import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Tina
 *
 */
public class HumanPlayer {
	Card c = new Card();
	Hand h = new Hand();
	Play p = new Play();
	Player r = new Player();
	Scanner in = new Scanner(System.in);
	int[] discardPile = new int[52];
	int[] cardsOfPlayer; 
	int[] actualCardsToBePlayed;
	private int card;
	
	private int current_card_to_play;
	public String[] cardToPlay = {
		"ACEs","TWOs","THREEs","FOURs","FIVEs","SIXs","SEVENs","EIGHTs","NINEs","TENs","JACKs","QUEENs","KINGs"
	};
	
	
	public void initialise(int players) {
		int[] cardsArray = c.shuffle();
		System.out.println("Deck: ");
		for(int t = 0; t < cardsArray.length; t++) {
			System.out.print(cardsArray[t]+ ", "); 
		}
		r.assignCards(players, cardsArray);
		
		Arrays.fill(discardPile, -1);
		int i = 0;
		int start = 0;
		int end = 0;
		int player;
		int q = 0;
		
		//some fn to assign cards to players from player.java
		boolean finished = false;
		boolean bluff = false;
		
		while (!finished) {
			current_card_to_play = (current_card_to_play + 1) % 13;
			//current_card_to_play = (current_card_to_play) % 13;
			if(current_card_to_play == 0) current_card_to_play = 13;
			System.out.println("Current card to be played: " + cardToPlay[current_card_to_play-1]);
			i = (i+1) % players;
			if(i == 0) {
				player = 4;
			}else player = i;
			System.out.println("Turn for Player " + player);
			int currentPlayer = player-1;
			//r.assignCards(players, cardsArray);
			
			int counter = 0;
			for (int ii : r.getPlayersList().get(currentPlayer)){
				if(counter % 2 == 0) {
					System.out.println();
				}
				if(ii != 100){
					String s1 = String.format("%1$-20s", c.getDeck()[ii]);
	                System.out.print(counter+" - "+s1);
					counter++;
				}
			}
			System.out.println();
			System.out.println("Player "+player+ " cards: ");
			System.out.println(Arrays.toString(r.getPlayersList().get(currentPlayer)));
			
//			r.getPlayersList().add(0, changedArray);
			//int[] playerCards = c.displayCards(start,end);
			Integer[] playerCardsArray = r.getPlayersList().get(currentPlayer);
			Integer[] playerCardsArray0 = r.getPlayersList().get(0);
			System.out.println("playerCardsArray0 "+Arrays.toString(playerCardsArray0));
			Integer[] playerCardsArray1 = r.getPlayersList().get(1);
			System.out.println("playerCardsArray1 "+Arrays.toString(playerCardsArray1));
			Integer[] playerCardsArray2 = r.getPlayersList().get(2);
			System.out.println("playerCardsArray2 "+Arrays.toString(playerCardsArray2));
			Integer[] playerCardsArray3 = r.getPlayersList().get(3);
			System.out.println("playerCardsArray3 "+Arrays.toString(playerCardsArray3));
//-----------------------------------------------------------------------------------------------------
			discardPile = getCardsToDeal(currentPlayer, playerCardsArray, discardPile);
			int challenger = 1;
			for(int k = 1; k < players; k++){
				if(challenger == player) {
					if(player == 4) challenger = 0;
					else challenger = challenger +1;
				}
				bluff = p.callBluff(challenger);
				if(bluff){
					actualCardsToBePlayed = c.getActualCardsToBePlayed(current_card_to_play);
					boolean verdict = p.bluffVerifier(cardsOfPlayer,actualCardsToBePlayed);
					int loser;
					if(verdict){
						loser = currentPlayer;
						System.out.println("Caught! Player "+player+ " played wrong cards. The pile is now yours!");
					}else{
						loser = challenger-1;
						System.out.println("Player "+player+ " played correct cards. The pile goes to challenger.");
					}
					discardPile = r.addDiscardPileToPlayerCards(loser, playerCardsArray, discardPile);
					
					break;
					
				} else {
					challenger = challenger +1;
				}
			}
			int winner =  findWinner();
			if(winner != 0) finished = true;
			System.out.println("Player "+winner+" is the winner!!!");
		}
		System.out.println("\nPress any key to continue or enter Q to quit>\n");
		String str = in.nextLine();
		if (str.equals("Q") || str.equals("q") || str.equals("quit")) {
			finished = true;
		}
	}
//-----------------------------------------------------------------------------------------------------

	/**
	 * @return 
	 * 
	 */
	private int findWinner() {
		// TODO Auto-generated method stub
		int winner = 0;
		Integer[] player0 = r.getPlayersList().get(0);
		Integer[] player1 = r.getPlayersList().get(1);
		Integer[] player2 = r.getPlayersList().get(2);
		Integer[] player3 = r.getPlayersList().get(3);
		int len0 = player0.length;
		int len1 = player1.length;
		int len2 = player2.length;
		int len3 = player3.length;
		if(len0 == 0) winner = 1;
		else if(len1 == 0) winner = 2;
		else if(len2 == 0) winner = 3;
		else if(len3 == 0) winner = 4;
		return winner;
	}
	private int[] getCardsToDeal(int player, Integer[] playerCardsArray, int[] discardPile) {
		// TODO Auto-generated method stub
		this.discardPile = discardPile;
		System.out.println("Enter the no. of cards: "); 
		int num = in.nextInt();		
		System.out.println("Enter card numbers in CSV format: "); //eg: 3,1,2
		String str = in.nextLine();
		str = in.nextLine();
		int positions[] = new int[num];
		String[] temp = str.split(",");
		for(int i = 0; i < temp.length; i++){
			positions[i] = Integer.parseInt(temp[i]);
		}
		//cardsOfPlayer has the cards the player just played. Serve as a temp storage.
		cardsOfPlayer = p.getCardsOfPlayer(positions, playerCardsArray, discardPile);
		//Object[] obj  = r.removeCards(player, positions, discardPile);
		discardPile  = r.removeCards(player, positions, discardPile);
		System.out.println("discardPile: ");
		for(int i = 0; i < discardPile.length; i++){
			System.out.print(discardPile[i]+ " , ");
		}
		
		return discardPile;
	}

}